Loading...
Searching...
No Matches
attributes.h File Reference

Macro definitions for various function/variable attributes. More...

Go to the source code of this file.

## Macros

#define | AV_GCC_VERSION_AT_LEAST(x, y)
#define | AV_GCC_VERSION_AT_MOST(x, y)
#define | AV_HAS_BUILTIN(x)
#define | av_always_inline __attribute__((always_inline)) inline
#define | av_extern_inline inline
#define | av_warn_unused_result __attribute__((warn_unused_result))
#define | av_noinline __attribute__((noinline))
#define | av_pure __attribute__((pure))
#define | av_const __attribute__((const))
#define | av_cold __attribute__((cold))
#define | av_flatten __attribute__((flatten))
#define | attribute_deprecated __attribute__((deprecated))
#define | AV_NOWARN_DEPRECATED(code)
| Disable warnings about deprecated features This is useful for sections of code kept for backward compatibility and scheduled for removal.
#define | av_unused __attribute__((unused))
#define | av_used __attribute__((used))
| Mark a variable as used and prevent the compiler from optimizing it away.
#define | av_alias __attribute__((may_alias))
#define | av_uninit(x)
#define | av_builtin_constant_p __builtin_constant_p
#define | av_printf_format(fmtpos, attrpos)
#define | av_scanf_format(fmtpos, attrpos)
#define | av_noreturn __attribute__((noreturn))

## Detailed Description

Macro definitions for various function/variable attributes.

Definition in file attributes.h.

## Macro Definition Documentation

## AV_GCC_VERSION_AT_LEAST

#define AV_GCC_VERSION_AT_LEAST | ( |  | x,
|  |  | y )

Value:
(__GNUC__ > (x) || __GNUC__ == (x) && __GNUC_MINOR__ >= (y))

Definition at line 30 of file attributes.h.

## AV_GCC_VERSION_AT_MOST

#define AV_GCC_VERSION_AT_MOST | ( |  | x,
|  |  | y )

Value:
(__GNUC__ < (x) || __GNUC__ == (x) && __GNUC_MINOR__ <= (y))

Definition at line 31 of file attributes.h.

## AV_HAS_BUILTIN

#define AV_HAS_BUILTIN | ( |  | x | ) |

Value:
0

Definition at line 40 of file attributes.h.

## av_always_inline

#define av_always_inline __attribute__((always_inline)) inline

Definition at line 45 of file attributes.h.

Referenced by av_bswap16(), av_bswap32(), av_ceil_log2_c(), av_clip64_c(), av_clip_c(), av_clip_int16_c(), av_clip_int8_c(), av_clip_intp2_c(), av_clip_uint16_c(), av_clip_uint8_c(), av_clip_uintp2_c(), av_clipd_c(), av_clipf_c(), av_clipl_int32_c(), av_double2int(), av_float2int(), av_iamf_param_definition_alloc(), av_int2double(), av_int2float(), av_inv_q(), av_parity_c(), av_popcount64_c(), av_popcount_c(), av_sat_add32_c(), av_sat_add64_c(), av_sat_dadd32_c(), av_sat_dsub32_c(), av_sat_sub32_c(), av_sat_sub64_c(), av_zero_extend_c(), and avio_tell().

## av_extern_inline

#define av_extern_inline inline

Definition at line 57 of file attributes.h.

## av_warn_unused_result

#define av_warn_unused_result __attribute__((warn_unused_result))

Definition at line 62 of file attributes.h.

Referenced by av_audio_fifo_alloc(), av_buffersrc_add_frame(), av_buffersrc_parameters_set(), av_buffersrc_write_frame(), av_dynarray_add(), av_realloc(), avformat_init_output(), avformat_write_header(), and sws_isSupportedEndiannessConversion().

## av_noinline

#define av_noinline __attribute__((noinline))

Definition at line 68 of file attributes.h.

## av_pure

#define av_pure __attribute__((pure))

Definition at line 76 of file attributes.h.

Referenced by av_adler32_update(), and av_crc().

## av_const

#define av_const __attribute__((const))

Definition at line 82 of file attributes.h.

Referenced by av_add_q(), av_bswap16(), av_bswap32(), av_bswap64(), av_ceil_log2_c(), av_clip64_c(), av_clip_c(), av_clip_int16_c(), av_clip_int8_c(), av_clip_intp2_c(), av_clip_uint16_c(), av_clip_uint8_c(), av_clip_uintp2_c(), av_clipd_c(), av_clipf_c(), av_clipl_int32_c(), av_d2q(), av_div_q(), av_gcd(), av_isdigit(), av_isgraph(), av_isspace(), av_isxdigit(), av_log2(), av_log2_16bit(), av_mul_q(), av_parity_c(), av_popcount64_c(), av_popcount_c(), av_rescale(), av_rescale_q(), av_rescale_q_rnd(), av_rescale_rnd(), av_sub_q(), av_tolower(), av_toupper(), and av_zero_extend_c().

## av_cold

#define av_cold __attribute__((cold))

Definition at line 88 of file attributes.h.

## av_flatten

#define av_flatten __attribute__((flatten))

Definition at line 94 of file attributes.h.

## attribute_deprecated

#define attribute_deprecated __attribute__((deprecated))

Definition at line 100 of file attributes.h.

Referenced by av_opt_eval_q(), and av_packet_free().

## AV_NOWARN_DEPRECATED

#define AV_NOWARN_DEPRECATED | ( |  | code | ) |

Value:
_Pragma("GCC diagnostic push") \
_Pragma("GCC diagnostic ignored \"-Wdeprecated-declarations\"") \
code \
_Pragma("GCC diagnostic pop")

Disable warnings about deprecated features This is useful for sections of code kept for backward compatibility and scheduled for removal.

Definition at line 114 of file attributes.h.

## av_unused

#define av_unused __attribute__((unused))

Definition at line 131 of file attributes.h.

## av_used

#define av_used __attribute__((used))

Mark a variable as used and prevent the compiler from optimizing it away.

This is useful for variables accessed only from inline assembler without the compiler being aware.

Definition at line 142 of file attributes.h.

## av_alias

union unaligned_16 av_alias __attribute__((may_alias))

Definition at line 148 of file attributes.h.

## av_uninit

#define av_uninit | ( |  | x | ) |

Value:
x=x

Definition at line 154 of file attributes.h.

## av_builtin_constant_p

#define av_builtin_constant_p __builtin_constant_p

Definition at line 160 of file attributes.h.

## av_printf_format

#define av_printf_format | ( |  | fmtpos,
|  |  | attrpos )

Value:
__attribute__((__format__(__printf__, fmtpos, attrpos)))

Definition at line 161 of file attributes.h.

Referenced by av_asprintf(), av_bprintf(), av_log(), av_log_once(), av_strlcatf(), and avio_printf().

## av_scanf_format

#define av_scanf_format | ( |  | fmtpos,
|  |  | attrpos )

Value:
__attribute__((__format__(__scanf__, fmtpos, attrpos)))

Definition at line 162 of file attributes.h.

Referenced by av_sscanf().

## av_noreturn

#define av_noreturn __attribute__((noreturn))

Definition at line 170 of file attributes.h.